using System.Collections.Generic;
using System.Collections;
using System;
using System.Linq;
using Aurora.Utils;

#nullable enable
namespace Aurora.Cursor
{

    public class CursorList<T> : SortedList<string, T> where T : ICursorObject
    {

        public CursorList()
        {
        }

        public CursorList<T> Add(T item)
        {
            string itemHashId = HashUtil.GetHash(new string[] { item.Id, item.GetHashCode().ToString() }).ToString();
            bool res = this.TryAdd(itemHashId, item);

            if (res == false)
            {
                throw new System.Exception("Failed to add item to cursor list");
            }
            return this;
        }


    }
}